package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZTASKTEAM;
import cn.ibizlab.core.sample.filter.IBIZTASKTEAMSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface IBIZTASKTEAMMapper extends BaseMapper<IBIZTASKTEAM> {

    Page<IBIZTASKTEAM> searchDefault(IPage page, @Param("srf") IBIZTASKTEAMSearchContext context, @Param("ew") Wrapper<IBIZTASKTEAM> wrapper);
    @Override
    IBIZTASKTEAM selectById(Serializable id);
    @Override
    int insert(IBIZTASKTEAM entity);
    @Override
    int updateById(@Param(Constants.ENTITY) IBIZTASKTEAM entity);
    @Override
    int update(@Param(Constants.ENTITY) IBIZTASKTEAM entity, @Param("ew") Wrapper<IBIZTASKTEAM> updateWrapper);
    @Override
    int deleteById(Serializable id);
    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<IBIZTASKTEAM> selectByRoot(@Param("ibiztaskid") Serializable ibiztaskid);

}
